=== debian/changelog ===
yquake2 (5.21~dfsg1-1) unstable; urgency=low

  * New upstream release
    - the refresher (renderer) is now directly linked into the executable
    - refresh patches
  * Standards-Version: 3.9.5 (no changes needed)
  * Release to unstable

 -- Simon McVittie <smcv@debian.org>  Mon, 13 Jan 2014 10:22:42 +0000

yquake2 (5.11.v2~dfsg1-1) experimental; urgency=low

  [ Fabian Greffrath ]
  * Initial release (Closes: #689824).
  * Filter potentially non-free stuff out of the upstream release tarball.
  * Append to {C,LD}FLAGS instead of overriding them,
    obey dpkg-buildflags thereby.
  * Install port-specific architecture-dependent files
    into a separate LIBDIR directory.
  * Fix spelling-errors detected by lintian.
  * Add Recommends: libgl1-mesa-glx | libgl1, libopenal1. They get dlopen()ed
    and should be installed in all but unusual installations. This way they
    also show up in reportbug templates.

  [ Simon McVittie ]
  * Add myself to Uploaders
  * Enable pristine-tar support
  * Fix git-import-orig filter syntax
  * Also filter out src/backends/sdl_osx since those files' origin and
    license are unclear
  * debian/copyright: document why this is in contrib, and how the
    orig tarball was filtered
  * Provide a virtual package for the quake2-engine
  * Take the engine and server off the $PATH, recommending the quake2
    package (from src:quake >= 4) as the "user-facing" Quake II package
  * Provide virtual packages for the quake2-engine and quake2-engine-server
  * Split out a yamagi-quake2-core package with the server and shared files
  * Link against libgl, libopenal1 libraries at compile time in the
    usual way, instead of dlopen() + Recommends
  * Set SYSTEMWIDE directory to the LIBDIR, so the wrapper scripts
    in the quake2, quake2-server packages can select either demo data
    (/usr/share/games/quake2-demo) or full data (/usr/share/games/quake2)
    if both are installed
  * yamagi-quake2-core: add Breaks/Replaces for the
    yamagi-quake2 packages provided by upstream
  * Upload to experimental

 -- Simon McVittie <smcv@debian.org>  Sun, 29 Sep 2013 14:38:45 +0100
