=== debian/rules ===
#!/usr/bin/make -f

DEB_CPPFLAGS_MAINT_APPEND += -DLIBDIR=\"/usr/lib/yamagi-quake2/\"
DEB_LDFLAGS_MAINT_APPEND  += -Wl,--as-needed -Wl,-z,defs
export DEB_CPPFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- \
		DLOPEN_LIBGL=no \
		DLOPEN_OPENAL=no \
		VERBOSE=1 \
		WITH_SYSTEMWIDE=yes \
		WITH_SYSTEMDIR="/usr/lib/yamagi-quake2/" \
		WITH_X11GAMMA=yes

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG

override_dh_installdocs:
	dh_installdocs CONTRIBUTE README
