## yquake2 5.30~dfsg1

=== Makefile ===
--- 
+++ 
@@ -10,6 +10,12 @@
 #  - SDL 1.2 or SDL 2.0                                  #
 #  - libGL                                               #
 #                                                        #
+# Further dependencies:                                  #
+#  - libogg                                              #
+#  - libvorbis                                           #
+#  - OpenAL                                              #
+#  - zlib                                                #
+#                                                        #
 # Platforms:                                             #
 #  - FreeBSD                                             #
 #  - Linux                                               #
@@ -38,10 +44,6 @@
 # installed
 WITH_OPENAL:=yes
 
-# Enables retexturing support. Adds
-# a dependency to libjpeg
-WITH_RETEXTURING:=yes
-
 # Use SDL2 instead of SDL1.2. Disables CD audio support,
 # because SDL2 has none. Use OGG/Vorbis music instead :-)
 # On Windows sdl-config isn't used, so make sure that
@@ -71,24 +73,35 @@
 # You have to make sure your libs/frameworks supports
 # these architectures! To build an universal ppc-compatible
 # one would add -arch ppc for example.
-OSX_ARCH:=-arch i386 -arch x86_64
+OSX_ARCH:=-arch $(shell uname -m | sed -e s/i.86/i386/)
 
 # This will set the build options to create an MacOS .app-bundle.
 # The app-bundle itself will not be created, but the runtime paths
-# will be set to expect the linked Frameworks in *.app/Contents/
-# Frameworks and the game-data will be expected in *.app/
+# will be set to expect the game-data in *.app/
 # Contents/Resources
 OSX_APP:=yes
 
-# ====================================================== #
-#     !!! DO NOT ALTER ANYTHING BELOW THIS LINE !!!      #
-# ====================================================== #
+# This is an optional configuration file, it'll be used in
+# case of presence.
+CONFIG_FILE := config.mk
+
+# ----------
+
+# In case a of a configuration file being present, we'll just use it
+ifeq ($(wildcard $(CONFIG_FILE)), $(CONFIG_FILE))
+include $(CONFIG_FILE)
+endif
 
 # Detect the OS
 ifdef SystemRoot
 OSTYPE := Windows
 else
 OSTYPE := $(shell uname -s)
+endif
+
+# Special case for MinGW
+ifneq (,$(findstring MINGW,$(OSTYPE)))
+OSTYPE := Windows
 endif
 
 # Detect the architecture
@@ -142,11 +155,12 @@
 #  generated if building universal binaries on OSX)
 ifeq ($(OSTYPE), Darwin)
 CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
-		  -Wall -pipe -g
+		  -Wall -pipe -g 
+		  #-isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.5.sdk
 CFLAGS += $(OSX_ARCH)
 else
 CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
-		  -Wall -pipe -g -MMD
+		  -Wall -pipe -g -ggdb -MMD
 endif
 
 # ----------
@@ -161,19 +175,28 @@
 
 # ----------
 
+# On Windows / MinGW $(CC) is
+# undefined by default.
+ifeq ($(OSTYPE),Windows)
+CC := gcc
+endif
+
+# ----------
+
 # Extra CFLAGS for SDL
-ifneq ($(OSTYPE), Windows)
-ifeq ($(OSTYPE), Darwin)
+ifeq ($(WITH_SDL2),yes)
+ifeq ($(OSTYPE),Windows)
+SDLCFLAGS := $(shell /custom/bin/sdl2-config --cflags)
+else
+SDLCFLAGS := $(shell sdl2-config --cflags)
+endif
+else # not SDL2
+ifeq ($(OSTYPE),Windows)
 SDLCFLAGS :=
-else # not darwin
-ifeq ($(WITH_SDL2),yes)
-SDLCFLAGS := $(shell sdl2-config --cflags)
-else # not SDL2
+else
 SDLCFLAGS := $(shell sdl-config --cflags)
+endif
 endif # SDL2
-
-endif # darwin's else
-endif # not windows
 
 # ----------
 
@@ -196,8 +219,8 @@
 INCLUDE := -I/usr/local/include
 else ifeq ($(OSTYPE),OpenBSD)
 INCLUDE := -I/usr/local/include
-else ifeq ($(OSTYPE),Darwin)
-INCLUDE :=
+else ifeq ($(OSTYPE),Windows)
+INCLUDE := -I/custom/include
 endif
 
 # ----------
@@ -210,7 +233,7 @@
 else ifeq ($(OSTYPE),OpenBSD)
 LDFLAGS := -L/usr/local/lib -lm
 else ifeq ($(OSTYPE),Windows)
-LDFLAGS := -lws2_32 -lwinmm
+LDFLAGS := -L/custom/lib -static -lws2_32 -lwinmm
 else ifeq ($(OSTYPE), Darwin)
 LDFLAGS := $(OSX_ARCH) -lm
 endif
@@ -220,17 +243,15 @@
 # Extra LDFLAGS for SDL
 ifeq ($(OSTYPE), Windows)
 ifeq ($(WITH_SDL2),yes)
-SDLLDFLAGS := -lSDL2main -lSDL2  -mwindows  -lm -ldinput8 -ldxguid \
-	-ldxerr8 -luser32 -lgdi32 -lwinmm -limm32 -lole32 -loleaut32 \
-	-lshell32 -lversion -luuid
+SDLLDFLAGS := $(shell /custom/bin/sdl2-config --static-libs) 
 else # not SDL2
 SDLLDFLAGS := -lSDL
 endif # SDL2
 else ifeq ($(OSTYPE), Darwin)
 ifeq ($(WITH_SDL2),yes)
-SDLLDFLAGS := -framework SDL2 -framework OpenGL -framework Cocoa
+SDLLDFLAGS := -lSDL2 -framework OpenGL -framework Cocoa
 else # not SDL2
-SDLLDFLAGS := -framework SDL -framework OpenGL -framework Cocoa
+SDLLDFLAGS := -lSDL -framework OpenGL -framework Cocoa
 endif # SDL2
 else # not Darwin/Win
 ifeq ($(WITH_SDL2),yes)
@@ -267,7 +288,6 @@
 # ----------
 
 # Phony targets
-#.PHONY : all client game icon refresher server
 .PHONY : all client game icon server
 
 # ----------
@@ -281,7 +301,6 @@
 	@echo "============================"
 	@echo "WITH_CDA = $(WITH_CDA)"
 	@echo "WITH_OPENAL = $(WITH_OPENAL)"
-	@echo "WITH_RETEXTURING = $(WITH_RETEXTURING)"
 	@echo "WITH_SDL2 = $(WITH_SDL2)"
 	@echo "WITH_X11GAMMA = $(WITH_X11GAMMA)"
 	@echo "WITH_ZIP = $(WITH_ZIP)"
@@ -303,22 +322,16 @@
 ifeq ($(OSTYPE), Windows)
 icon:
 	@echo "===> WR build/icon/icon.res"
-	${Q}stuff/misc/mkdir -p build/icon
+	${Q}mkdir -p build/icon
 	${Q}windres stuff\icon\icon.rc -O COFF -o build\icon\icon.res
 endif
 
 # ----------
 
 # Cleanup
-ifeq ($(OSTYPE), Windows)
-clean:
-	@echo "===> CLEAN"
-	@-rmdir /S /Q release build
-else
 clean:
 	@echo "===> CLEAN"
 	${Q}rm -Rf build release
-endif
 
 # ----------
 
@@ -326,12 +339,12 @@
 ifeq ($(OSTYPE), Windows)
 client:
 	@echo "===> Building quake2.exe"
-	${Q}stuff/misc/mkdir.exe -p release
+	${Q}mkdir -p release
 	$(MAKE) release/quake2.exe
 
 build/client/%.o: %.c
 	@echo "===> CC $<"
-	${Q}stuff/misc/mkdir.exe -p $(@D)
+	${Q}mkdir -p $(@D)
 	${Q}$(CC) -c $(CFLAGS) $(SDLCFLAGS) $(INCLUDE) -o $@ $<
 
 ifeq ($(WITH_CDA),yes)
@@ -351,18 +364,13 @@
 release/quake2.exe : CFLAGS += -DZIP -DNOUNCRYPT
 release/quake2.exe : LDFLAGS += -lz
 endif
- 
-ifeq ($(WITH_RETEXTURING),yes)
-release/quake2.exe : CFLAGS += -DRETEXTURE
-release/quake2.exe : LDFLAGS += -ljpeg
-endif 
 
 ifeq ($(WITH_SDL2),yes)
 release/quake2.exe : CFLAGS += -DSDL2
 endif
 
 release/quake2.exe : LDFLAGS += -mwindows -lopengl32
-else
+else # not Windows
 client:
 	@echo "===> Building quake2"
 	${Q}mkdir -p release
@@ -386,19 +394,14 @@
 
 ifeq ($(WITH_OGG),yes)
 release/quake2 : CFLAGS += -DOGG
-ifeq ($(OSTYPE), Darwin)
-release/quake2 : LDFLAGS += -framework Vorbis -framework Ogg
-else
 release/quake2 : LDFLAGS += -lvorbis -lvorbisfile -logg
-endif
 endif
 
 ifeq ($(WITH_OPENAL),yes)
 ifeq ($(OSTYPE), OpenBSD)
 release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.so"'
 else ifeq ($(OSTYPE), Darwin)
-release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"/System/Library/Frameworks/OpenAL.framework/OpenAL"'
-release/quake2 : LDFLAGS += -framework OpenAL
+release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.dylib"'
 else
 release/quake2 : CFLAGS += -DUSE_OPENAL -DDEFAULT_OPENAL_DRIVER='"libopenal.so.1"'
 endif
@@ -413,23 +416,8 @@
 release/quake2 : CFLAGS += -DX11GAMMA
 endif
 
-ifeq ($(WITH_RETEXTURING),yes)
-release/quake2 : CFLAGS += -DRETEXTURE
-ifeq ($(OSTYPE), Darwin)
-release/quake2 : LDFLAGS += -framework libjpeg
-else
-release/quake2 : LDFLAGS += -ljpeg
-endif
-endif
-
 ifeq ($(WITH_SDL2),yes)
 release/quake2 : CFLAGS += -DSDL2
-endif
- 
-ifeq ($(OSTYPE), Darwin)
-ifeq ($(OSX_APP), yes)
-release/quake2 : LDFLAGS += -Xlinker -rpath -Xlinker @loader_path/../Frameworks
-endif
 endif
  
 ifneq ($(OSTYPE), Darwin)
@@ -453,3 +441,21 @@
 ifeq ($(OSTYPE), FreeBSD)
 release/quake2 : LDFLAGS += -Wl,-z,origin,-rpath='/usr/share/games/quake2/lib'
 else ifeq ($(OSTYPE), Linux)
+release/quake2 : LDFLAGS += -Wl,-z,origin,-rpath='/usr/share/games/quake2/lib'
+endif
+endif
+endif
+endif
+
+# ----------
+
+# The server
+ifeq ($(OSTYPE), Windows)
+server:
+	@echo "===> Building q2ded"
+	${Q}mkdir -p release
+	$(MAKE) release/q2ded.exe
+
+build/server/%.o: %.c
+	@echo "===> CC $<"
+	${Q}mkdir -p $(@D)
