=== debian/changelog ===
yquake2 (5.30~dfsg1-1) unstable; urgency=medium

  * New upstream release
    - update debian/copyright
    - refresh patches
    - drop patch adding LIBDIR: the engine now looks for files relative
      to the executable, which happens to be exactly the directory we were
      using as our LIBDIR
  * Use https and cgit for Vcs-Browser
  * Stop using numbered patches for gbp pq
  * Add patch to replace __DATE__ with BUILDDATE, and define that macro
    from the debian/changelog date
    - build with TZ=UTC and LC_ALL=C.UTF-8 to make that deterministic
  * Drop libjpeg-dev build-dependency, yquake2 now has its own simplistic
    JPEG loader

 -- Simon McVittie <smcv@debian.org>  Tue, 05 May 2015 11:02:44 +0100

yquake2 (5.21~dfsg1-2) unstable; urgency=medium

  * Change libjpeg8-dev build-dependency to libjpeg-dev for libjpeg-turbo
    transition
  * Standards-Version: 3.9.6 (no changes needed)

 -- Simon McVittie <smcv@debian.org>  Thu, 09 Oct 2014 08:07:27 +0100
