=== debian/control ===
--- 
+++ 
@@ -8,17 +8,16 @@
 Build-Depends:
  debhelper (>= 9),
  libgl1-mesa-dev | libgl-dev,
- libjpeg8-dev,
  libopenal-dev,
  libsdl2-dev,
  libvorbis-dev,
  libxrandr-dev,
  libxxf86vm-dev,
  zlib1g-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.yamagi.org/quake2/
 Vcs-Git: git://anonscm.debian.org/pkg-games/yquake2.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/yquake2.git;a=summary
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/yquake2.git
 
 Package: yamagi-quake2
 Architecture: any-amd64 any-i386
