=== debian/rules ===
--- 
+++ 
@@ -1,13 +1,23 @@
 #!/usr/bin/make -f
 
-DEB_CPPFLAGS_MAINT_APPEND += -DLIBDIR=\"/usr/lib/yamagi-quake2/\"
+export LC_ALL=C.UTF-8
+export TZ=UTC
+
+DEB_CPPFLAGS_MAINT_APPEND += -I$(CURDIR) -include debian/yquake2.h
 DEB_LDFLAGS_MAINT_APPEND  += -Wl,--as-needed -Wl,-z,defs
 export DEB_CPPFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_APPEND
 
 %:
 	dh $@
 
-override_dh_auto_build:
+debian/yquake2.h:
+	date --utc --date="`dpkg-parsechangelog -SDate`" \
+		"+#define BUILDDATE \"%b %_d %Y\"" > $@
+
+export LC_ALL=C.UTF-8
+export TZ=UTC
+
+override_dh_auto_build: debian/yquake2.h
 	dh_auto_build -- \
 		DLOPEN_LIBGL=no \
 		DLOPEN_OPENAL=no \
