=== Makefile ===
--- 
+++ 
@@ -155,12 +155,12 @@
 #  generated if building universal binaries on OSX)
 ifeq ($(OSTYPE), Darwin)
 CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
-		  -Wall -pipe -g 
+		  -Wall -pipe -g -fwrapv
 		  #-isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.5.sdk
 CFLAGS += $(OSX_ARCH)
 else
 CFLAGS := -O2 -fno-strict-aliasing -fomit-frame-pointer \
-		  -Wall -pipe -g -ggdb -MMD
+		  -Wall -pipe -g -ggdb -MMD -fwrapv
 endif
 
 # ----------
@@ -233,7 +233,7 @@
 else ifeq ($(OSTYPE),OpenBSD)
 LDFLAGS := -L/usr/local/lib -lm
 else ifeq ($(OSTYPE),Windows)
-LDFLAGS := -L/custom/lib -static -lws2_32 -lwinmm
+LDFLAGS := -L/custom/lib -lws2_32 -lwinmm
 else ifeq ($(OSTYPE), Darwin)
 LDFLAGS := $(OSX_ARCH) -lm
 endif
@@ -243,7 +243,7 @@
 # Extra LDFLAGS for SDL
 ifeq ($(OSTYPE), Windows)
 ifeq ($(WITH_SDL2),yes)
-SDLLDFLAGS := $(shell /custom/bin/sdl2-config --static-libs) 
+SDLLDFLAGS := $(shell /custom/bin/sdl2-config --libs)
 else # not SDL2
 SDLLDFLAGS := -lSDL
 endif # SDL2
