=== debian/changelog ===
yquake2 (5.32~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 5.32
  * Remove debian/patches/000*, applied upstream.

 -- Fabian Greffrath <fabian@debian.org>  Mon, 02 Nov 2015 10:43:42 +0100

yquake2 (5.31~dfsg1-2) unstable; urgency=medium

  [ Simon McVittie ]
  * Move patches from upstream to the beginning of the patch series,
    and add DEP-3 metadata
  * Split rpath-avoidance into a separate patch

  [ Fabian Greffrath ]
  * Add patch by Simon McVittie to override the default basedir
    instead of adding a path if SYSTEMWIDE is defined.
    + This lets "+set basedir" take precedence over the SYSTEMDIR,
      which is useful if you have the demo and full-game data installed
      in different base directories to be able to test the demo for
      regressions.
  * Add debian/yquake2.h to debian/clean to make sure it gets
    regenerated for each package revision.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 06 Oct 2015 14:14:06 +0200

yquake2 (5.31~dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 5.31~dfsg1
    + Backport two commits from upstream GIT to fix crosshair scaling
      (Closes: #799952).
    + Refresh patches.
  * Do not hard-code WITH_SYSTEMDIR at build time anymore. The engine expects
    the renderer in the same directory anyway and game data is expected in
    /usr/share/games/quake2, where this defaults to (Closes: #800118).
    + Extend debian/patches/Append...patch to also remove the bogus rpaths
      instructions from LDFLAGS.
  * Update Uploaders field and packaging Copyright to my <fabian@debian.org>
    address.
  * Add "Recommends: quake2" to the yamagi-quake2 package and
    "Recommends: quake2-server | yamagi-quake2" to yamagi-quake2-core.
  * Remove debian/README.source, did not contain any relevant information
    anymore.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 29 Sep 2015 11:59:24 +0200
