=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
- Fabian Greffrath <fabian+debian@greffrath.com>,
+ Fabian Greffrath <fabian@debian.org>,
  Simon McVittie <smcv@debian.org>
 Build-Depends:
  debhelper (>= 9),
@@ -25,6 +25,7 @@
  yamagi-quake2-core (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends: quake2
 Provides: quake2-engine
 Description: enhanced version of id Software's Quake II - client
  This is the Yamagi Quake II Client, an enhanced Version of id Software's
@@ -41,6 +42,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends: quake2-server | yamagi-quake2
 Provides: quake2-engine-server
 Breaks: yamagi-quake2 (<< 5.11)
 Replaces: yamagi-quake2 (<< 5.11)
