=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,6 @@
 		DLOPEN_OPENAL=no \
 		VERBOSE=1 \
 		WITH_SYSTEMWIDE=yes \
-		WITH_SYSTEMDIR="/usr/lib/yamagi-quake2/" \
 		WITH_X11GAMMA=yes
 
 override_dh_installchangelogs:
