## yquake2 5.34~dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,22 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
 
 # Enforce "Debug" as standard build type
 if(NOT CMAKE_BUILD_TYPE)
-  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
-endif(NOT CMAKE_BUILD_TYPE)
+	set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
+endif()
 
 # CMake project configuration
-project (yquake2)
+project(yquake2)
 
 # Cmake module search path
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/stuff/cmake/modules ${CMAKE_MODULE_PATH})
 
-if (YQUAKE2LIBS)
-	set(ENV{CMAKE_PREFIX_PATH} ${YQUAKE2LIBS})
+if(YQUAKE2LIBS)
+	if(CMAKE_CROSSCOMPILING)
+		set(CMAKE_FIND_ROOT_PATH ${YQUAKE2LIBS})
+	else()
+		set(ENV{CMAKE_PREFIX_PATH} ${YQUAKE2LIBS})
+	endif()
 
 	set(ENV{OPENALDIR} ${YQUAKE2LIBS})
 	set(ENV{SDLDIR} ${YQUAKE2LIBS})
@@ -36,6 +40,7 @@
 option(ZIP_SUPPORT "ZIP support" ON)
 option(OGG_SUPPORT "OGG Vorbis playback support (Music)" ON)
 option(OPENAL_SUPPORT "OpenAL support" ON)
+option(SYSTEMWIDE_SUPPORT "Enable systemwide installation of game assets" OFF)
 
 # These variables will act as our list of include folders and linker flags
 set(yquake2LinkerFlags)
@@ -49,6 +54,20 @@
 set(GAME_SRC_DIR ${SOURCE_DIR}/game)
 set(SERVER_SRC_DIR ${SOURCE_DIR}/server)
 set(CLIENT_SRC_DIR ${SOURCE_DIR}/client)
+
+# Operating system
+add_definitions(-DOSTYPE="${CMAKE_SYSTEM_NAME}")
+
+# Architecture string
+string(REGEX REPLACE "amd64" "x86_64" ARCH ${CMAKE_SYSTEM_PROCESSOR})
+string(REGEX REPLACE "i.86" "i386" ARCH ${ARCH})
+string(REGEX REPLACE "^arm.*" "arm" ARCH ${ARCH})
+add_definitions(-DARCH="${ARCH}")
+
+# Systemwide installation of game assets
+if(${SYSTEMWIDE_SUPPORT})
+    add_definitions(-DSYSTEMWIDE)
+endif()
 
 # Required libraries to build the different components of the binaries. Find
 # them and add the include/linker directories and flags (in case the package
@@ -119,10 +138,10 @@
 link_directories(${yquake2LinkerDirectories})
 
 set(Backends-Generic-Source
+	${BACKENDS_SRC_DIR}/generic/misc.c
 	${BACKENDS_SRC_DIR}/generic/qal.c
+	${BACKENDS_SRC_DIR}/generic/qgl.c
 	${BACKENDS_SRC_DIR}/generic/vid.c
-	${BACKENDS_SRC_DIR}/generic/qgl.c
-	${BACKENDS_SRC_DIR}/generic/misc.c
 
 	${BACKENDS_SRC_DIR}/sdl/cd.c
 	${BACKENDS_SRC_DIR}/sdl/input.c
@@ -137,11 +156,11 @@
 	)
 
 set(Backends-Unix-Source
-	${BACKENDS_SRC_DIR}/unix/network.c
-	${BACKENDS_SRC_DIR}/unix/system.c
 	${BACKENDS_SRC_DIR}/generic/misc.c
 	${BACKENDS_SRC_DIR}/unix/main.c
+	${BACKENDS_SRC_DIR}/unix/network.c
 	${BACKENDS_SRC_DIR}/unix/signalhandler.c
+	${BACKENDS_SRC_DIR}/unix/system.c
 	${BACKENDS_SRC_DIR}/unix/shared/hunk.c
 	)
 
@@ -151,6 +170,7 @@
 
 set(Backends-Windows-Source
 	${BACKENDS_SRC_DIR}/generic/misc.c
+	${BACKENDS_SRC_DIR}/windows/icon.rc
 	${BACKENDS_SRC_DIR}/windows/network.c
 	${BACKENDS_SRC_DIR}/windows/system.c
 	${BACKENDS_SRC_DIR}/windows/shared/mem.c
@@ -340,23 +360,3 @@
 	${CLIENT_SRC_DIR}/refresh/files/stb_image.h
 	${CLIENT_SRC_DIR}/refresh/header/local.h
 	${CLIENT_SRC_DIR}/refresh/header/model.h
-	${CLIENT_SRC_DIR}/sound/header/cdaudio.h
-	${CLIENT_SRC_DIR}/sound/header/local.h
-	${CLIENT_SRC_DIR}/sound/header/sound.h
-	${CLIENT_SRC_DIR}/sound/header/vorbis.h
-	${COMMON_SRC_DIR}/header/common.h
-	${COMMON_SRC_DIR}/header/crc.h
-	${COMMON_SRC_DIR}/header/files.h
-	${COMMON_SRC_DIR}/header/glob.h
-	${COMMON_SRC_DIR}/header/shared.h
-	${COMMON_SRC_DIR}/header/zone.h
-	${COMMON_SRC_DIR}/unzip/ioapi.h
-	${COMMON_SRC_DIR}/unzip/unzip.h
-	${SERVER_SRC_DIR}/header/server.h
-	)
-
-set(Server-Source
-	${COMMON_SRC_DIR}/argproc.c
-	${COMMON_SRC_DIR}/clientserver.c
-	${COMMON_SRC_DIR}/collision.c
-	${COMMON_SRC_DIR}/crc.c
