=== debian/changelog ===
yquake2 (5.34~dfsg1-1) unstable; urgency=medium

  * Switch Vcs-Git to https (see #810378)
  * Standards-Version: 3.9.8 (no changes needed)
  * New upstream release
    - no longer specific to amd64 and i386 (Closes: #826689)
    - install 3D crosshair for stereoscopic rendering
    - refresh patches
    - install new README.md instead of old README
  * Enable full compiler hardening
  * Rewrite __DATE__ patch to use SOURCE_DATE_EPOCH directly
  * debian/gbp.conf: use DEP-14 branch names

 -- Simon McVittie <smcv@debian.org>  Fri, 01 Jul 2016 08:55:49 +0100
